<?php 
/**
 * @name MgS_TimeManager Moodle Block Module
 * @author Sternadel Michał (http://sternadel.pl)
 * @copyright Sternadel Michał
 * @version 1.0.3MgS Moodle 2.0 compliant
 * @release-date 2012-02-16 14:16:02
 * @abstract Moodle block module to show time spent on each course, providing usefull report to administrators or teachers
 * 
 **/

class block_mgs_timemanager extends block_base {
	
	
	private $isadmin = false;
	
	function init() {
		global $USER;
		$this->title = get_string('blockName', 'block_mgs_timemanager');
		$this->version = '2012021601';
		$this->cron = 600;
		
		$admins = get_admins();
		foreach ($admins as $admin) {
			if ($USER->id == $admin->id) {
				$this->isadmin = true; 
				break;
			}
			//ticzera sprawdzac po kursie
		}
		/* if ($isadmin) {
			// Show all
		} else {
			// Check institution
		} */
	}
	function isteacher($courseId) {
		$context = get_context_instance(CONTEXT_COURSE, $courseId);
		if(has_capability('moodle/course:update', $context)) return true;
		return false;
	}
	
	function isadmin() {
		return $this->isadmin;
	}
	/**
	*
	* Debug dowolnej wartości
	* @param any $cosik
	* @return boolean
	*/
	function deb($cosik) {
		echo '<div style="margin-top: 100px; color: #330000; border: 2px #eecccc solid; background: #ffeeee; padding: 10px; z-index: 999!important;">
			<strong>Debug:</strong>
			<pre style="color: #000000!important;">';
		var_dump($cosik);
		echo '</pre>
			</div>';
		return true;
	}
	
	
	function has_config() {
		return true;
	}
	
	function instance_allow_config() {
		global $COURSE;
        if ($this->isadmin && $COURSE->id > 1) return true;
        if ($this->isteacher($COURSE->id)) {
            if ($COURSE->id > 1)
                return true;
        }
        return false;
	} 
	
	function preferred_width() {
		return 220;
	}
	
	function cron() {
		mtrace("MgS_timemanager reports that cron dummy function is running...");
		return true;
	}
	
	function get_content() {
		global $USER, $COURSE, $CFG, $DB, $OUTPUT;
		if ($this->content !== NULL) return $this->content;
		
		$this->content = new stdClass; 
		
		if ($USER->id && $USER->id!=1) {
			if ($COURSE->id=="1") { //jesli strona glowna:
				if ($this->isadmin) {
					$courses=$this->getCoursesForAdmin();
					$kurs='all_admin';
				}
				else { 
						$courses=$this->getCoursesForUser($USER->id);
						$kurs='all';	
				}
				if ($courses) {
					/*
					$blocktype = $DB->get_record('block', array('name' => 'mgs_timemanager') );
					$instances = $DB->get_records('block_instances', array('blockid' => $blocktype->id) );
					foreach ($instances as $instance) {
					$configdata[$instance->pageid]=unserialize(base64_decode($instance->configdata))->block_mgs_timemanager_timeLimit;
					if ($configdata[$instance->pageid]) $required[$instance->pageid]=$this->secondsToTime($configdata[$instance->pageid]); else $required[$instance->pageid]=$this->secondsToTime($CFG->block_mgs_timemanager_timeLimit);
					}
					*/
						
					/* $instance = $DB->get_record('block_instances', array('blockname' => 'mgs_timemanager'), '*', MUST_EXIST);
					$block = block_instance('mgs_timemanager', $instance);
					$this->deb($block);
					*/
					$this->content->text .= "\n<!-- copyright (c) Sternadel Michał http://sternadel.pl/?from=moodletimemanager Wszelkie prawa zastrzeżone -->\n";
					$this->content->text .= '<table style="width: 100%; font-size: 85%;" border="0" cellspacing="0" cellpadding="2" >';
					$this->content->text .= '<tr><td>' . get_string('course') . ':</td><td>' . get_string('timeSpent', 'block_mgs_timemanager') . ':</td><td>' . get_string('timeRequired', 'block_mgs_timemanager') . ':</td></tr>';
				
					foreach ($courses as $course) {
						
						$instance = get_context_instance(CONTEXT_COURSE, $course->courseid);
						$data=$DB->get_record('block_instances', array('blockname' => 'mgs_timemanager', 'parentcontextid' => $instance->id), 'configdata');
						if ($data) {
							$string=base64_decode($data->configdata);
							$this->blockconfig=unserialize($string);
						}
						if (isset($this->blockconfig->block_mgs_timemanager_timeLimit)) $CFG->block_mgs_timemanager_timeLimit=$this->blockconfig->block_mgs_timemanager_timeLimit;
						
						$required[$course->courseid]=$this->secondsToTime($CFG->block_mgs_timemanager_timeLimit);
						
						$wartosci=$this->getStats($USER->id, $course->courseid);
						//if ($required[$course->courseid] && $wartosci->input >= $required[$course->courseid]->input) $this->content->text .='<tr style="background-color: '.$CFG->block_mgs_timemanager_highlightColor.'; font-weight: bold;">';
						//if ($this->secondsToTime($this->config->block_mgs_timemanager_timeLimit) && $wartosci->input >= $required[$course->courseid]->input) $this->content->text .='<tr style="background-color: '.$this->config->block_mgs_timemanager_highlightColor.'; font-weight: bold;">';
						if ($CFG->block_mgs_timemanager_timeLimit && $wartosci->input >= $CFG->block_mgs_timemanager_timeLimit) $this->content->text .='<tr style="background-color: '.$CFG->block_mgs_timemanager_highlightColor.'; font-weight: bold;">';
						else $this->content->text .='<tr>';
						$this->content->text .= '<td>';
						$this->content->text .= '<a href="'. $CFG->wwwroot .'/course/view.php?id=' . $course->courseid . '">' . $course->coursenameshort.'</a>';
						$this->content->text .= '</td><td>';
						$this->content->text .= $wartosci->hours . ' ' . get_string('hours') . ' ' . $wartosci->minutes . ' ' . get_string('mins');
						$this->content->text .= '</td><td>';
						if ($required[$course->courseid]) $this->content->text .= $this->getRequiredInfo($required[$course->courseid]->input);
						else $this->content->text .= $this->getRequiredInfo();
						$this->content->text .= '</td></tr>';
					} //foreach
					$this->content->text .= '<tr><td colspan="3" class="legend" style="text-align: center;">';
					$this->content->text .= get_string('timeGivenIsIndicative', 'block_mgs_timemanager');
					$this->content->text .= '</td></tr>';
					
					// return information from database about users who reach time limit on course:
					
					$sql="SELECT * FROM {$CFG->prefix}mgs_timemanager_completed WHERE acceptedby IS NULL";
 					$reached=$DB->get_records_sql($sql);
					if ($reached) {
						$predefinedHeader .='<tr><td colspan="3"><hr /></td></tr><tr><td colspan="3">'. get_string('usersWhoHaveReachedRequiredTime', 'block_mgs_timemanager') .':</td></tr>';
						$predefinedHeader .='<tr><td>'.get_string('course').':</td><td>'. get_string('firstname'). ' '. get_string('and', 'block_mgs_timemanager') .' ' .get_string('lastname').':</td><td>'.get_string('actions', 'block_mgs_timemanager').':</td></tr>';
						foreach ($reached as $reachedInfo) {
							if ($this->isadmin or ($this->isteacher($reachedInfo->courseid))) {
 								$userInfo=$DB->get_record('user', array('id' => $reachedInfo->userid));
								$courseInfo=$DB->get_record('course', array('id' => $reachedInfo->courseid));
 		    					$predefined .= '<tr><td>';
								$predefined .= '<a href="'. $CFG->wwwroot .'/course/view.php?id=' . $reachedInfo->courseid . '">' . $courseInfo->shortname.'</a>';
								$predefined .= '</td><td>';
 		    					$predefined .='<a href="'. $CFG->wwwroot .'/user/view.php?id=' . $reachedInfo->userid . '&amp;course='.$reachedInfo->courseid. '">' . $userInfo->firstname .' ' . $userInfo->lastname .'</a>';
								$predefined .= '</td><td style="text-align: center; width:48px;">';
								$counter['vatInvoice']=$this->getDownloadedCount($reachedInfo->userid, $reachedInfo->courseid, 'vatInvoice');
								$counter['certificate']=$this->getDownloadedCount($reachedInfo->userid, $reachedInfo->courseid, 'certificate');
								if ($counter['vatInvoice'] == 0) $predefined .='<a href="' .$CFG->wwwroot .'/blocks/mgs_timemanager/_get.php?report=vatInvoice&courseId=' .$reachedInfo->courseid .'&userId=' . $reachedInfo->userid.'" title="'. get_string('vatInvoice', 'block_mgs_timemanager'). ' ' . get_string('downloaded', 'block_mgs_timemanager').': ' . $counter['vatInvoice'] .' '. get_string('times', 'block_mgs_timemanager') .'"><img src="'.$OUTPUT->pix_url('/i/tick_amber_small').'" class="icon" alt="'. get_string('vatInvoice', 'block_mgs_timemanager') .'" /></a>';
					            else $predefined .='<a onclick="{if (confirm(\''.get_string('areYouSureYouWantToDownloadVatInvoice', 'block_mgs_timemanager').'\')) {return true;}else {return false;}}" href="' .$CFG->wwwroot .'/blocks/mgs_timemanager/_get.php?report=vatInvoice&courseId=' . $reachedInfo->courseid .'&userId=' . $reachedInfo->userid.'" title="'. get_string('vatInvoice', 'block_mgs_timemanager') .' ' . get_string('downloaded', 'block_mgs_timemanager').': ' . $counter['vatInvoice'] .' '. get_string('times', 'block_mgs_timemanager') .'"><img src="'.$OUTPUT->pix_url('/i/tick_green_small').'" class="icon" alt="'. get_string('vatInvoice', 'block_mgs_timemanager') .'" /></a>';
					            $predefined .='<a href="' .$CFG->wwwroot .'/blocks/mgs_timemanager/_get.php?report=certificate&courseId=' . $reachedInfo->courseid .'&userId=' . $reachedInfo->userid.'" title="'. get_string('certificate', 'block_mgs_timemanager') .' ' . get_string('downloaded', 'block_mgs_timemanager').': ' . $counter['certificate'] .' '. get_string('times', 'block_mgs_timemanager') .'"><img src="'.$OUTPUT->pix_url('/i/grades').'" class="icon" alt="'. get_string('certificate', 'block_mgs_timemanager') .'" /></a>';
								$predefined .= '<a onclick="{if (confirm(\''.get_string('areYouSureYouWantToHideInformation', 'block_mgs_timemanager').'\')) {return true;}else {return false;}}" href="' .$CFG->wwwroot .'/blocks/mgs_timemanager/_setCompleted.php?recordId='.$reachedInfo->id.'&courseId=' . $reachedInfo->courseid .'&userId=' . $reachedInfo->userid . '" title="'. get_string('markAsRead', 'block_mgs_timemanager') .'"><img src="'.$OUTPUT->pix_url('/i/hide').'" class="icon" alt="'. get_string('certificate', 'block_mgs_timemanager') .'" /></a>';
 		    					$predefined .= '</td></tr>';
							}	 					
	 					}
	 					if ($predefined) $this->content->text .=$predefinedHeader.$predefined;
					}				
					$this->content->text .= '</table>';	
					

				}
				else {
					$this->content->text .= "\n<!-- copyright (c) Sternadel Michał http://sternadel.pl/?from=moodletimemanager Wszelkie prawa zastrzeżone -->\n";
					$this->content->text .= '<table style="width: 100%; font-size: 85%;" border="0" cellspacing="0" cellpadding="2" >';
					$this->content->text .= '<tr><td colspan="3" class="legend" style="text-align: center;">';
					$this->content->text .= get_string('noLogsAvailable', 'block_mgs_timemanager');
					$this->content->text .= '</td></tr></table>';
				}
			} // courseid=1
			if ($COURSE->id != 1) { // dla strony glownej pokazujemy inne dane
				$wartosci=$this->getStats($USER->id, $COURSE->id);
				//var_dump($wartosci);
				
				if ($wartosci) {
					$this->content->text .= "\n<!-- copyright (c) Sternadel Michał http://sternadel.pl/?from=moodletimemanager Wszelkie prawa zastrzeżone -->\n";
					$this->content->text .= '<table style="width: 100%; font-size: 85%;" border="0" cellspacing="0" cellpadding="2" >';
					$this->content->text .= '<tr><td style="text-align: left;">' . get_string('timeSpent', 'block_mgs_timemanager') .':</td>';
					if ( ($wartosci->hours > 0) or ($wartosci->minutes > 0) ) {
						$this->content->text .= '<td  colspan="2" style="text-align: right;">';
						$this->content->text .= '<b>';
						$this->content->text .= $wartosci->hours . ' ' . get_string('hours') . ' ' . $wartosci->minutes . ' ' . get_string('mins');
						$this->content->text .= '</b>';
						$this->content->text .= '</td></tr>';
					}
					else {
						$this->content->text .='<td  colspan="2" style="text-align: center; font-weight: bold;">';
						$this->content->text .= get_string('noLogsAvailable', 'block_mgs_timemanager');
						$this->content->text .= '</td></tr>';
					}
					$this->content->text .= '<tr><td style="text-align: left;">' . get_string('timeRequired', 'block_mgs_timemanager') .':</td><td  colspan="2" style="text-align: right;">';
					$this->content->text .= '<b>' . $this->getRequiredInfo() . '</b>';
					$this->content->text .= '</td></tr>';

					// save information that user reach time limit on that course to the database (only once)
					if (!($this->isadmin and !($this->isteacher($COURSE->id)))) {
						if ($wartosci->input >= $CFG->block_mgs_timemanager_timeLimit && $this->isCompleted($USER->id, $COURSE->id)==0 && $this->isPrepared($USER->id, $COURSE->id)==0) $this->prepareCompleted($USER->id, $COURSE->id, $wartosci->input, $CFG->block_mgs_timemanager_timeLimit);
					}
				$kurs=$wartosci->course;
				//jesli administrator lub nauczyciel w tym kursie, pokaz czas dla poszczegolnych studentow:
				if ($this->isadmin or $this->isteacher($COURSE->id)) {
					$students=$this->getStudentsOnCourse($COURSE->id);
					if ($students) {
						$this->content->text .= '<tr><td colspan="3"><hr /></td></tr>';
						$this->content->text .= '<tr><td style="text-align: center;">' . get_string('users') . ':</td><td style="text-align: center;">' . get_string('time') . ':</td><td style="width: 40px; text-align: center;">' . get_string('actions', 'block_mgs_timemanager') . ':</td></tr>';
						foreach ($students as $student) {
							$wyniki=$this->getStats($student->userid, $student->courseid);
							if ($wyniki->input >=$this->config->block_mgs_timemanager_timeLimit) $this->content->text .='<tr style="background-color: '.$this->config->block_mgs_timemanager_highlightColor.'; font-weight: bold;">';
							elseif ($wyniki->input >=$CFG->block_mgs_timemanager_timeLimit) $this->content->text .='<tr style="background-color: '.$CFG->block_mgs_timemanager_highlightColor.'; font-weight: bold;">';
							else $this->content->text .= '<tr>';
							$this->content->text.='<td style="text-align: left;">';
							$this->content->text .='<a href="'. $CFG->wwwroot .'/user/view.php?id=' . $student->userid . '&amp;course='.$student->courseid. '">' . 
							$student->lastname. ' '. $student->firstname . '</a></td>';
							$this->content->text .= '<td style="text-align: right;">';
							$this->content->text .= $wyniki->hours . ' ' . get_string('hours') . ' ' . $wyniki->minutes . ' ' . get_string('mins');
							$this->content->text .='</td><td style="text-align: center;">';
							if ($wyniki->input >=$CFG->block_mgs_timemanager_timeLimit) {
								$counter['vatInvoice']=$this->getDownloadedCount($student->userid, $student->courseid, 'vatInvoice');
								$counter['certificate']=$this->getDownloadedCount($student->userid, $student->courseid, 'certificate');
								if ($counter['vatInvoice'] == 0) $this->content->text .='<a href="' .$CFG->wwwroot .'/blocks/mgs_timemanager/_get.php?report=vatInvoice&courseId=' . $student->courseid .'&userId=' . $student->userid.'" title="'. get_string('vatInvoice', 'block_mgs_timemanager'). ' ' . get_string('downloaded', 'block_mgs_timemanager').': ' . $counter['vatInvoice'] .' '. get_string('times', 'block_mgs_timemanager') .'"><img src="'.$OUTPUT->pix_url('/i/tick_amber_small').'" class="icon" alt="'. get_string('vatInvoice', 'block_mgs_timemanager') .'" /></a>';
					            else $this->content->text .='<a onclick="{if (confirm(\''.get_string('areYouSureYouWantToDownloadVatInvoice', 'block_mgs_timemanager').'\')) {return true;}else {return false;}}" href="' .$CFG->wwwroot .'/blocks/mgs_timemanager/_get.php?report=vatInvoice&courseId=' . $student->courseid .'&userId=' . $student->userid.'" title="'. get_string('vatInvoice', 'block_mgs_timemanager') .' ' . get_string('downloaded', 'block_mgs_timemanager').': ' . $counter['vatInvoice'] .' '. get_string('times', 'block_mgs_timemanager') .'"><img src="'.$OUTPUT->pix_url('/i/tick_green_small').'" class="icon" alt="'. get_string('vatInvoice', 'block_mgs_timemanager') .'" /></a>';
					            //tick_amber_small.gif
					            $this->content->text .='<a href="' .$CFG->wwwroot .'/blocks/mgs_timemanager/_get.php?report=certificate&courseId=' . $student->courseid .'&userId=' . $student->userid.'" title="'. get_string('certificate', 'block_mgs_timemanager') .' ' . get_string('downloaded', 'block_mgs_timemanager').': ' . $counter['certificate'] .' '. get_string('times', 'block_mgs_timemanager') .'"><img src="'.$OUTPUT->pix_url('/i/grades.').'" class="icon" alt="'. get_string('certificate', 'block_mgs_timemanager') .'" /></a>';
					             
							}
							else $this->content->text .= '--';	            
				            $this->content->text .='</td></tr>';						
						} //foreach
						// link do pobierania raportu w rtf:
						//$this->content->footer='<a href="' .$CFG->wwwroot .'/blocks/mgs_stats/getreport.php?courseId=' . $student->courseId .'">' . get_string('getReport', 'block_mgs_timemanager') . '</a>';
						$this->content->footer='<a href="' .$CFG->wwwroot .'/blocks/mgs_timemanager/_get.php?report=timeSpent&courseId=' . $student->courseid .'">' . get_string('getReport', 'block_mgs_timemanager') . '</a>';
					}
		    	} // admin/teacher
				$this->content->text .= '<tr><td colspan="3" style="text-align: center;"><hr />';
				$this->content->text .= get_string('timeGivenIsIndicative', 'block_mgs_timemanager');
				$this->content->text .= '</td></tr>';
			} //wartosci
			else {
				$this->content->text .='<tr><td colspan="3" class="level0" style="text-align: center;">';
				$this->content->text .= get_string('noavailablelogs', 'block_mgs_stats');
				$this->content->text .= '</td></tr>';
			}			
		$this->content->text .= '</table>';
	} //courseId != 1	
	//copyright		
	$this->content->text .= '<div style="text-align:center; font-size: 6pt;">(c) <a style="font-size: 6pt;" title="Sternadel Michał" href="http://sternadel.pl/?from=moodle_tm-';
	$this->content->text .= strtolower(str_replace(' ', '', str_replace('"','', $kurs)));
	$this->content->text .= '" target="_Blank">Sternadel Michał</a>';
	$this->content->text .= '</div>';
	return $this->content;        
	} //userid
	}
	
	
	
	//////////////////////////
	// additional functions //
	//////////////////////////
	
	/**
	 * Zwraca listę kursów dla admina
	 */
	function getCoursesForAdmin() {
		global $CFG, $DB;
		$pyt="
			SELECT 
			{$CFG->prefix}course.id as \"courseId\",		
			{$CFG->prefix}course.shortname as \"courseNameShort\"
			FROM {$CFG->prefix}course
			WHERE {$CFG->prefix}course.id != '1'
			ORDER BY {$CFG->prefix}course.id ASC";	
		return $DB->get_records_sql($pyt);
	}
	
	/**
	* Zwraca informacje o kursie
	*/
	function getCourseInfo($courseId) {
		global $CFG, $DB;
		$pyt="SELECT 
				{$CFG->prefix}course.id,
				{$CFG->prefix}course.shortname,
				{$CFG->prefix}course.fullname
				FROM {$CFG->prefix}course
				WHERE {$CFG->prefix}course.id = '$courseId'";
		return $DB->get_record_sql($pyt);
	}
	
	/**
	 * Pobiera kursy dla uzytkownika
	 */
	function getCoursesForUser($userId) {
		global $CFG, $DB;
		$pyt="
			SELECT 
			{$CFG->prefix}course.id as \"courseId\",
			{$CFG->prefix}course.shortname as \"courseNameShort\" 
			FROM {$CFG->prefix}course
			INNER JOIN {$CFG->prefix}context ON {$CFG->prefix}context.instanceid = {$CFG->prefix}course.id
			LEFT JOIN {$CFG->prefix}role_assignments ON {$CFG->prefix}role_assignments.contextid = {$CFG->prefix}context.id
			WHERE {$CFG->prefix}role_assignments.userid='$userId'
			ORDER BY {$CFG->prefix}course.id ASC";
		return $DB->get_records_sql($pyt);	
	}

	/**
	 * Pobiera liste studentow na podanym kursie
	 */
	function getStudentsOnCourse($courseId) {
		global $CFG, $USER, $DB;
		$pyt="
			SELECT 
			{$CFG->prefix}user.id as \"userId\",
			CONCAT('$courseId') as \"courseId\",
			{$CFG->prefix}user.firstname as \"firstname\",
			{$CFG->prefix}user.lastname as \"lastname\"
			FROM {$CFG->prefix}course
			INNER JOIN {$CFG->prefix}context ON {$CFG->prefix}context.instanceid = {$CFG->prefix}course.id
			INNER JOIN {$CFG->prefix}role_assignments ON {$CFG->prefix}role_assignments.contextid = {$CFG->prefix}context.id
			INNER JOIN {$CFG->prefix}user ON {$CFG->prefix}user.id = {$CFG->prefix}role_assignments.userid
			--	WHERE {$CFG->prefix}role_assignments.userid='$USER->id'
			WHERE {$CFG->prefix}course.id = '$courseId'
			AND {$CFG->prefix}user.id != '$USER->id'
			AND {$CFG->prefix}role_assignments.roleid = '5'							
			ORDER BY {$CFG->prefix}user.lastname, {$CFG->prefix}user.firstname ASC";
		return $DB->get_records_sql($pyt);
	}
	
	function getAdditionalStudentInfo($userId) {
		global $CFG, $DB;
		$pyt="
			SELECT 
			{$CFG->prefix}user.id,
			{$CFG->prefix}user.firstname,
			{$CFG->prefix}user.lastname
			FROM {$CFG->prefix}user
			WHERE {$CFG->prefix}user.id = $userId
			LIMIT 1
			";
		return $DB->get_record_sql($pyt);	
	}

	function getStudentInfo($userId) {
		global $CFG, $DB;
		// $DB->execute('SET @i=1;');
		
		$pyt="
			SELECT 
			@i as RAND_NUM,	@i:=@i+1,
			{$CFG->prefix}user.firstname,
			{$CFG->prefix}user.lastname
			FROM {$CFG->prefix}user
			WHERE {$CFG->prefix}user.id = $userId
			
			";
		return $DB->get_record_sql($pyt);	
	}
	
	
	/**
	 * Zwraca objekt godzin minut oraz wejsciowe sekundy z sekund
	 */
	function secondsToTime($timeInSeconds) {
		$value = new stdClass;
		$value->input=$timeInSeconds;
		$value->hours = 0;
		$value->minutes = 0;
			
		if($timeInSeconds >= 3600) {
			$value->hours = floor($timeInSeconds/3600);
			$timeInSeconds = ($timeInSeconds%3600);
		}
		if($timeInSeconds >= 60) {
			$value->minutes = floor($timeInSeconds/60);
			$timeInSeconds = ($timeInSeconds%60);
		}
		
		return $value;
	}
	
	/**
	 * 
	 * Zwraca data zapisu na kurs, w ostateczności datę pierwszej aktywności, a w ostatecznej ostateczności datę dzisiejszą.
	 * @param unknown_type $userId
	 * @param unknown_type $courseId
	 */
	function getEnrolDate($userId, $courseId) {
		global $CFG, $DB;
		$sql="SELECT {$CFG->prefix}role_assignments.id, min(timemodified) as time FROM {$CFG->prefix}role_assignments
		INNER JOIN {$CFG->prefix}context on {$CFG->prefix}context.id = {$CFG->prefix}role_assignments.contextid
		WHERE {$CFG->prefix}role_assignments.userid='$userId'
		AND {$CFG->prefix}context.instanceid='$courseId'
		AND {$CFG->prefix}role_assignments.roleid='5'
		
		";
		$enrol=$DB->get_record_sql($sql);
		if ($enrol) return $enrol->time;
		else {
			$info=get_record('user', 'id', $userId );
			if ($info) return $info->firstaccess;
			else return mktime();
		}
		return mktime();
	}
	
	/**
	 * Zwraca statystyki godzin, minut oraz daty i czas pierwszej, i ostatniej aktywnosci
	 */
	function getStats($userId, $courseId=null) {
		global $USER, $CFG, $COURSE, $DB;
		if (!$CFG->block_mgs_timemanager_threshold) $roznicaczasumax=60*30; else $roznicaczasumax=$CFG->block_mgs_timemanager_threshold;
		if (!$CFG->block_mgs_timemanager_timeAdd) $naliczpowylogowaniu=60*0; else $naliczpowylogowaniu=$CFG->block_mgs_timemanager_timeAdd;
		// if (!$CFG->block_mgs_timemanager_timeLimit) $timeLimit=60*60*4; else $timeLimit=$CFG->block_mgs_timemanager_timeLimit;
	
		$value=array();
		$pyt= "SELECT {$CFG->prefix}log.id as \"id\",";
	
		if ($courseId) {
			$pyt.="
			{$CFG->prefix}course.fullname as \"kursfull\", 
			{$CFG->prefix}course.shortname as \"kurs\", ";
		} else {
			$pyt.="
				CONCAT('". get_string('allcourses', 'block_mgs_stats') . "') as \"kurs\", 
				CONCAT('". get_string('allcourses', 'block_mgs_stats') . "') as \"kursfull\",";
			
		}
		$pyt.="
		{$CFG->prefix}log.time as helper_time
		from {$CFG->prefix}log
		INNER JOIN {$CFG->prefix}user on {$CFG->prefix}user.id = {$CFG->prefix}log.userid
		INNER JOIN {$CFG->prefix}course on {$CFG->prefix}course.id = {$CFG->prefix}log.course
		WHERE
		{$CFG->prefix}log.userid = '$userId'";
		if ($courseId) {
			$pyt.="
			AND {$CFG->prefix}log.course = '$courseId'";
		}
		$pyt .="
		ORDER BY {$CFG->prefix}log.time ASC,
		{$CFG->prefix}log.course ASC";

		$wynik=$DB->get_records_sql($pyt);
		$wynik=array_values($wynik);
	
		$iter=1;
		$spedzonyczas=0;
		$count=count($wynik);
		foreach ($wynik as $nazwa => $wartosc) {
			if ($iter<$count) {
				$kurs=$wynik[$iter]->kurs;
				$poprzedniczas=$wynik[$iter-1]->helper_time;
				$obecnyczas=$wynik[$iter]->helper_time;		
				if (!($obecnyczas)) $poprzedniczas=$obecnyczas;
				$roznicaczasu=$obecnyczas-$poprzedniczas;
				////
				if ($roznicaczasu <= $roznicaczasumax) {
					$nalicz=$roznicaczasu;
				}
				else {
					$nalicz=$naliczpowylogowaniu;
				}
				$spedzonyczas=$spedzonyczas+$nalicz;
				$iter++;
			}
		}//foreach
		/////

		$value=$this->secondsToTime($spedzonyczas);
		$value->firstActivity=$wynik[0]->helper_time;
		$value->course=$wynik[0]->kurs;
		$value->coursefull=$wynik[0]->kursfull;
		$value->lastActivity=$wynik[count($wynik)-1]->helper_time;
		return $value;

	}
	
	/**
	 * 
	 * Zwraca informacje o czasie wymaganym na danym kursie:
	 */
	function getRequiredInfo($input=null) {
		global $CFG;
		if ($input) {
				$info=$this->secondsToTime($input);
				return $info->hours . ' ' . get_string('hours') . ' ' . $info->minutes . ' ' . get_string('mins');
		}
		else {
			//if (!$CFG->block_mgs_timemanager_timeLimit) $timeLimit=60*60*4; else $timeLimit=$CFG->block_mgs_timemanager_timeLimit;
			if ($this->config->block_mgs_timemanager_timeLimit) $CFG->block_mgs_timemanager_timeLimit = $this->config->block_mgs_timemanager_timeLimit;
			if ($CFG->block_mgs_timemanager_timeLimit === NULL) $CFG->block_mgs_timemanager_timeLimit = 60*60*4;
			
		//	$info=$this->secondsToTime($timeLimit);
			$info=$this->secondsToTime($CFG->block_mgs_timemanager_timeLimit);
			return $info->hours . ' ' . get_string('hours') . ' ' . $info->minutes . ' ' . get_string('mins');
		}
		return false;
	}
	
	/**
	 * zapisuje info do bazy, ze faktura zostala pobrana.
	 * @param unknown_type $studentId
	 * @param unknown_type $courdeId
	 */
	function setDownloaded($studentId, $courseId, $teacherId, $documentType) {
		global $DB;
		$record = new stdClass;
		$record->userid=$studentId;
		$record->courseid=$courseId;
		$record->teacherid=$teacherId;
		$record->documenttype=$documentType;
		$record->created=date('Y-m-d H:i:s', mktime());
		$DB->insert_record('mgs_timemanager_downloaded', $record);
		return true;
	}
	
	function getDownloadedCount($studentId, $courseId, $documentType) {
		global $DB;
		$records=$DB->get_records('mgs_timemanager_downloaded', array('documenttype'=> $documentType, 'userid'=> $studentId, 'courseid'=> $courseId));
		return (count($records));
	}

	/**
	 * 
	 * Wpisuje do bazy osoby, ktore uzyskaly limit czasu przewidziany na kurs
	 * @param unknown_type $studentId
	 * @param unknown_type $courseId
	 * @param unknown_type $spent
	 * @param unknown_type $required
	 */
	function prepareCompleted($studentId, $courseId, $spent, $required) {
		global $COURSE, $CFG, $USER, $DB;
		$record = new stdClass;
		$record->userid=$studentId;
		$record->courseid=$courseId;
		$record->spent=$spent;
		$record->required=$required;
		$record->acceptedby=null;
		$record->created=date('Y-m-d H:i:s', mktime());
		$record->modified=null;
		// send mail:
		if (isset($this->config->block_mgs_timemanager_sendNofiticationViaEmail) && $this->config->block_mgs_timemanager_sendNofiticationViaEmail==1 && isset($this->config->block_mgs_timemanager_keeperEmail)) {
	
			$mail = get_mailer();
			$mail->Sender=$USER->email;
			$mail->From = $CFG->noreplyaddress;
			$mail->FromName = $mail->From;
			$mail->Subject = get_string('limitReached', 'block_mgs_timemanager');
			$mail->AddAddress($this->config->block_mgs_timemanager_keeperEmail);
			$mail->AddBCC($CFG->block_mgs_timemanager_keeperEmail);
			$mail->isHTML(false);
			$mail->Body = get_string('notificationEmail', 'block_mgs_timemanager');
			$mail->Body .= get_string('course') . ': ' . $COURSE->fullname;
			$mail->Body .= "\r". get_string('date') . ': ' .date('Y-m-d H:i:s', mktime());
			$mail->Body .= "\r". $CFG->wwwroot .'/user/view.php?id='. $studentId . '&course=' . $courseId;
			$mail->Body .= "\r".'--'."\r" .get_string('emailWasSentAutomaticaly', 'block_mgs_timemanager');
			$mail->Send();
		}

		return $DB->insert_record('mgs_timemanager_completed', $record);
		// return true;
	}
	
	
	function setCompleted($id, $studentId, $courseId, $teacherId) {
		global $DB;
		$record = new stdClass();
		$record->id = (int)$id;
		$record->acceptedby=$teacherId;
		$record->modified=date('Y-m-d H:i:s', mktime());
//		var_dump($record);
		$DB->update_record('mgs_timemanager_completed', $record);
		return true;
	}
	
	function isPrepared($studentId, $courseId) {
		global $DB;
		return count($DB->get_records('mgs_timemanager_completed', array('userid' => $studentId, 'courseid' => $courseId))); 
	}

	function isCompleted($studentId, $courseId) {
		global $DB;
		return count($DB->get_records('mgs_timemanager_completed', array('userid' => $studentId, 'courseid' => $courseId, 'acceptedby' => 'NOT NULL'))); 
	}
	
	
	function legend($name) {
		print_string('cfg_'.$name, 'block_mgs_timemanager');
		echo '<br /><small>';
		print_string('cfg_'.$name.'_info', 'block_mgs_timemanager');
		echo '</small>';
	}

	function input($name, $default=null, $type='global') {
		global $CFG;
		if ($type=='global') {
			$block='block_mgs_timemanager_'.$name;	
			echo '<input name="'.$block.'" type="text" size="20" value="';
			if(isset($CFG->$block)) p($CFG->$block);
		   	else p($default);
	   	 	echo '" />';
			echo '<hr style="width:100% height:1px; border:0px; background-color: #444444;" />';
		}
		else {
			$block='block_mgs_timemanager_'.$name;	
			echo '<input name="'.$block.'" type="text" size="20" value="';
			if(isset($this->config->$block)) p($this->config->$block);
	   		elseif(isset($CFG->$block)) p($CFG->$block);
			else p($default);
    		echo '" />';
			echo '<hr style="width:100% height:1px; border:0px; background-color: #444444;" />';
	
		}
	
	}
	
	function checkbox($name, $default=null, $type='global') {
		global $CFG;
		if ($type=='global') {
			$block='block_mgs_timemanager_'.$name;	
			echo '<input name="'.$block.'" type="checkbox" value="1" ';
			if ($CFG->$block==1) echo 'checked ';
	   	 	echo ' />';
			echo '<hr style="width:100% height:1px; border:0px; background-color: #444444;" />';
		}
		else {
			$block='block_mgs_timemanager_'.$name;	
			$block='block_mgs_timemanager_'.$name;	
			echo '<input name="'.$block.'" type="checkbox" value="1" ';
			if ($this->config->$block==1) echo 'checked ';
	   	 	echo ' />';
			echo '<hr style="width:100% height:1px; border:0px; background-color: #444444;" />';
		}
	
	}
	
	
}
